//
//  BCTemperatureSensor.m
//  ANTDemo
//
//  Created by Umeno Katsuhiko on 13/06/10.
//  Copyright (c) 2013年 Umeno Katsuhiko. All rights reserved.
//

#import "BCTemperatureSensor.h"

NSString* const BCTemperatureSensorUpdate = @"BCTemperatureSensorUpdate";

#define TEMP_DEVICE_TYPE    0
#define TEMP_PERIOD         0.5     // Hz
#define TEMP_FREQ           2466    // Mhz

@implementation BCTemperatureSensor : SensorCommon

@synthesize temperature = _temperature;

-(id) initWithChannelNumber:(UInt8)channel
{
    self = [super initWithChannelNumber:channel];
    if (self) {
        // TemperatureSensor Setting
        self.deviceType = TEMP_DEVICE_TYPE;
        self.period = 32768 / TEMP_PERIOD;
        self.frequency = TEMP_FREQ - 2400;
    }
    
    return self;
}

// Override from SennsorCommon
- (void) didBroadcastDataReceive:(UInt8*)data length:(UInt8)length
{
    [super didBroadcastDataReceive:data length:length];
    NSLog(@"TemperatureSensor:didBroadcastDataReceive length=%u",length);

    // Parse Temperature data
    _temperature = (NSInteger)data[3];
    
    NSLog(@"Temp:%d", _temperature);
    
    NSNotification* notify = [NSNotification notificationWithName:BCTemperatureSensorUpdate object:self];
    [[NSNotificationCenter defaultCenter] postNotification:notify];
}

@end
