//
//  SensorCommon.h
//  ANTSensorDemo
//
//  Created by Umeno Katsuhiko on 13/06/10.
//  Copyright (c) 2013年 Umeno Katsuhiko. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BCANT.h"

typedef enum {
    BC_SENSOR_STATE_INIT                = 0,
    BC_SENSOR_STATE_CHANNEL_OPENING,
    BC_SENSOR_STATE_OPEN_FAILED,
    BC_SENSOR_STATE_SEARCH,
    BC_SENSOR_STATE_CONNECTED,
    BC_SENSOR_STATE_SEARCH_TIMEOUT,
    BC_SENSOR_STATE_CHANNEL_CLOSED,
} ANTSensorState;

@class SensorCommon;

@protocol SensorDelegate <NSObject>

- (void) didSensorStateChanged:(NSInteger)type state:(ANTSensorState)state sensor:(SensorCommon*)sensor;

@end


@interface SensorCommon : NSObject <BCANTDelegate>

@property (nonatomic, assign) NSInteger type;
@property (nonatomic, assign) UInt8 channel;
@property (nonatomic, assign) UInt16 deviceNumber;
@property (nonatomic, assign) UInt8 deviceType;
@property (nonatomic, assign) UInt8 transType;
@property (nonatomic, assign) UInt16 period;
@property (nonatomic, assign) UInt8 frequency;
@property (nonatomic, assign, readonly) ANTSensorState state;
@property (nonatomic, readwrite, weak) id<SensorDelegate> delegate;

-(id) initWithChannelNumber:(UInt8)channel;

-(void) start:(UInt16)deviceNumber;
-(void) stop;

// Handler Methods
- (void) didStartCompleted;
- (void) didStartFaild;
- (void) didStopCompleted;
- (void) didStopFaild;

- (void) didSearchTimeout;
- (void) didGoToSearch;
- (void) didChannelClosed;
- (void) didReceiveFaile;

- (void) didBroadcastDataReceive:(UInt8*)data length:(UInt8)length;

@end

