//
//  BCANT.h
//  BCANT
//
//  Created by Umeno Katsuhiko on 12/08/24.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BCANTAccessory.h"
//#import "BCANTCommandTransfer.h"
#import "BCANTCommandReceive.h"

@protocol BCANTDelegate <NSObject>

- (void) channelEventFunction:(UInt8)channel eventID:(UInt8)eventID data:(UInt8*)data length:(UInt8)length;
- (void) notificationFunction:(UInt8)msgID data:(UInt8*)data length:(UInt8)length;

@end


@interface BCANT : NSObject <BCANTReceiveDelegate>
{
    /*
@private
    BCANTAccessory*             _accessory;
    BCANTCommandTransfer*       _transfer;
    BCANTCommandReceive*        _receiver;
    NSMutableArray*             _channelDelegates;
     */
}

+ (BCANT*) shardANT;

//- (id) initWithAccessory:(BCANTAccessory*)accessory;
//- (BCANTAccessory*) accessory;

- (BOOL) getFreeChannel:(UInt8*)channel;
- (BOOL) registerChannelDelegate:(UInt8)channel delegate:(id<BCANTDelegate>)delegate;
- (BOOL) unregisterChannelDelegate:(UInt8)channel delegate:(id<BCANTDelegate>)delegate;

//
// Send Configuration Messages (sync methods)
//
- (NSInteger) unAssignChannel:(UInt8)channel waitSecs:(NSInteger)secs;
- (NSInteger) assignChannel:(UInt8)channel channelType:(UInt8)channelType networkNumber:(UInt8)networkNumber waitSecs:(NSInteger)secs;
- (NSInteger) assignChannelExt:(UInt8)channel channelType:(UInt8)channelType networkNumber:(UInt8)networkNumber extend:(UInt8)extend waitSecs:(NSInteger)secs;
- (NSInteger) setChannelId:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType waitSecs:(NSInteger)secs;
- (NSInteger) setChannelPeriod:(UInt8)channel messagePeriod:(UInt16)messagePeriod waitSecs:(NSInteger)secs;
- (NSInteger) setChannelSerachTimeout:(UInt8)channel searchTimeout:(UInt8)serachTimeout waitSecs:(NSInteger)secs;
- (NSInteger) setChannelRFFreq:(UInt8)channel RFFreq:(UInt8)RFFreq waitSecs:(NSInteger)secs;
- (NSInteger) setNetworkKey:(UInt8)netNumber pubKey:(UInt8*)pubKey waitSecs:(NSInteger)secs;
- (NSInteger) setTransmitPower:(UInt8)transmitPower waitSecs:(NSInteger)secs;
- (NSInteger) addChannelID:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType listIndex:(UInt8)listIndex waitSecs:(NSInteger)secs;
- (NSInteger) configList:(UInt8)channel listSize:(UInt8)listSize exelude:(UInt8)exelude waitSecs:(NSInteger)secs;
- (NSInteger) setChannelTxPower:(UInt8)channel txPower:(UInt8)txPower waitSecs:(NSInteger)secs;
- (NSInteger) setLowPriorityChannelSerachTimeout:(UInt8)channel serachTimeout:(UInt8)searchTimeout waitSecs:(NSInteger)secs;
- (NSInteger) setSerialNumChannelId:(UInt8)channel deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType waitSecs:(NSInteger)secs;
- (NSInteger) RxExtMesgsEnable:(UInt8)enable waitSecs:(NSInteger)secs;
- (NSInteger) enableLED:(UInt8)enable waitSecs:(NSInteger)secs;
- (NSInteger) crystalEnable:(NSInteger)secs;
- (NSInteger) LibConfig:(UInt8)libConfig waitSecs:(NSInteger)secs;
- (NSInteger) configFrequencyAgility:(UInt8)channel frequency1:(UInt8)frequency1 frequency2:(UInt8)frequency2 frequency3:(UInt8)frequency3 waitSecs:(NSInteger)secs;
- (NSInteger) setProximitySearch:(UInt8)channel searchThreshold:(UInt8)searchThreshold waitSecs:(NSInteger)secs;
- (NSInteger) setChannelSerachPriority:(UInt8)channel searchPriority:(UInt8)searchPriority waitSecs:(NSInteger)secs;

//
// Send Control Messages
//
- (NSInteger) resetSystem;
- (NSInteger) openChannel:(UInt8)channel waitSecs:(NSInteger)secs;
- (NSInteger) closeChannel:(UInt8)channel waitSecs:(NSInteger)secs;
//- (NSInteger) requestMessage:(UInt8)channel messageID:(UInt8)messageID;
- (NSInteger) openRxScanMode:(NSInteger)secs;
- (NSInteger) sleepMessage;

//
// Send Request Messages (sync methods)
//
- (NSInteger) getChannelStatus:(UInt8)channel channelType:(UInt8*)channelType networkNumber:(UInt8*)networkNumber channelState:(UInt8*)channelState waitSecs:(NSInteger)secs;
- (NSInteger) getChannelID:(UInt8)channel deviveNumber:(UInt16*)deviceNumber deviceType:(UInt8*)deviceType transmissionType:(UInt8*)transmissionType waitSecs:(NSInteger)secs;
- (NSString*) getANTVersion:(NSInteger)secs;
- (NSInteger) getCapabilities:channel maxChannels:(UInt8*)maxChannels maxNetworks:(UInt8*)maxNetworks standardOptions:(UInt8*)standardOptions advancedOptions:(UInt8*)advancedOptions advancedOptions2:(UInt8*)advancedOptions2 waitSecs:(NSInteger)secs;

//
// Send Data Messages
//
- (NSInteger) sendBroadcastData:(UInt32)channel broadcastData:(UInt8*)broadcastData length:(UInt8)length;
- (NSInteger) sendAcknowledgedData:(UInt8)channel acknowledgedData:(UInt8*)acknowledgedData length:(UInt8)length;
//- (NSInteger) ANT_SendBurstTransfer:(UInt8)channel data:(UInt8*)data numDataPackets:(UInt16)numDataPackets;
- (NSInteger) sendBurstTransferPacket:(UInt8)channel seqNo:(UInt8)seqNo data:(UInt8*)data length:(UInt8)length;

//
// Send Legacy Ext Data Messages
//
- (NSInteger) sendExtBroadcastData:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType data:(UInt8*)data length:(UInt8)length;
- (NSInteger) sendExtAcknowledgedData:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType data:(UInt8*)data length:(UInt8)length;
- (NSInteger) sendExtBurstTransferPacket:(UInt8)channel seqNO:(UInt8)seqNo deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType data:(UInt8*)data length:(UInt8)length;

//
// Test Mode
//
- (NSInteger) initCWTestMode:(NSInteger)secs;
- (NSInteger) setCWTestMode:(UInt8) txPower RFFresq:(UInt8)RFFreq waitSecs:(NSInteger)secs;

@end
