//
//  BCANTCommandReceive.h
//
//  Created by Umeno Katsuhiko on 12/08/15.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BCANTAccessory.h"
#import "BCANTResponseQueue.h"

@protocol BCANTReceiveDelegate <NSObject>

- (void) channelEventFunction:(UInt8)channel eventID:(UInt8)eventID data:(UInt8*)data length:(UInt8)length;
- (void) notificationFunction:(UInt8)msgID data:(UInt8*)data length:(UInt8)length;

@end

@interface BCANTCommandReceive : NSObject <BCANTAccessoryDelegate>
{
//    id<BCANTReceiveDelegate>    __weak delegate;
/*
@private
    BCANTAccessory*             _antAcc;
    BCANTResponseQueue*         _responseQueue;
    UInt8                       _currentResponseMsgID;
    NSData*                     _currentResponseData;
 */
}

@property (nonatomic, weak) id<BCANTReceiveDelegate> delegate;

- (id) initWithAccessory:(BCANTAccessory*)accessory;
- (BCANTAccessory*) accessory;

- (NSInteger) waitRespons:(NSInteger)secs;
- (NSInteger) waitChannelResponse:(UInt8)messageID secs:(NSInteger)secs;
- (NSInteger) waitRespons:(UInt8) msgID response:(BCANTResponse**)response secs:(NSInteger)secs;

@end
