//
//  BCDebug.h
//
//  Created by Katsuhiko Umeno on 12/07/31.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#ifndef __BC_DEBUG_H__
#define __BC_DEBUG_H__

//#import <Foundation/Foundation.h>

//#define USE_NSLOGGER

#ifdef USE_NSLOGGER
#import "Logger/LoggerClient.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

// Initialize Loger
extern void BC_LOGER_INIT(NSString* hostName, UInt32 port);
// Debug Log
extern void BC_DEBUG_LOG(NSString* format, ...);


#ifdef DEBUG

// Initialize Loger
#ifdef USE_NSLOGGER
#define LOGGER_INIT(host, port)         BC_LOGER_INIT(host, port)

//#define DLOG(fmt, ...)                  LogMessageCompat(fmt, ##__VA_ARGS__)
#define DLOG(fmt, ...)                  do{} while(0)
#define ELOG(fmt, ...)                  LogMessageCompat(fmt, ##__VA_ARGS__)
#define ILOG(fmt, ...)                  LogMessageCompat(fmt, ##__VA_ARGS__) 
    
#else
    
#define LOGGER_INIT(host, port)         do{} while(0)
    
//#define DLOG(fmt, ...)                  NSLog(fmt, ##__VA_ARGS__)
#define DLOG(fmt, ...)                  do{} while(0)
#define ELOG(fmt, ...)                  NSLog(fmt, ##__VA_ARGS__)
#define ILOG(fmt, ...)                  NSLog(fmt, ##__VA_ARGS__)
    
#endif
#else

#define LOGGER_INIT(HOST, PORT)         do{} while(0)
#define DLOG(fmt, ...)                  do{} while(0)
#define ELOG(fmt, ...)                  NSLog(fmt, ##__VA_ARGS__)
#define ILOG(fmt, ...)                  NSLog(fmt, ##__VA_ARGS__) 
    
#endif

#endif  // __BC_DEBUG_H__

#ifdef __cplusplus
};
#endif